#ifndef PROXY_H
#define PROXY_H


#include <stdarg.h>

#include <tcp++/tcp_client.h>
#include <tcp++/tcp_server.h>

#include "strlib.h"

class Proxy : public TcpServer
 {
  protected:
      char* spoof_user_agent;
      char* filter_app;
      char* filter_bin;
      char** filter_args;
      int pipe_on;

      void handle_client(int client_socket_fd);
      void parse_request(char *request, char* method, char* host, int& port, char* file,
       char* protocol);
      void forward_reply(FILE* in, FILE* out, TcpClient *http_client);
      void send_get(FILE* in, FILE* out, TcpClient* http_client);
      void send_post(FILE* in, FILE* out, TcpClient* http_client);
      
      void fix_user_agent(char* relay_buf);

  public:

   Proxy(int port, int listen_queue_size, char* log_file) : 
     TcpServer(port, listen_queue_size, log_file), spoof_user_agent(NULL),
      filter_app(NULL), pipe_on(0), filter_bin(0), filter_args(0)
    {
    }
   void set_spoof_user_agent(char* init_spoof_user_agent)
    {
     spoof_user_agent = init_spoof_user_agent;
    }
   void set_filter_app(char* init_filter_app)
    {
     filter_app = init_filter_app;
     debug(4, "filter_app = %s\n", filter_app);
     filter_args = str_arg_split(filter_app);
     if(!filter_args)
      fatal_error("Could not parse filter app string: %s", filter_app);

     filter_bin = filter_args[0];
     debug(4 , "filter_bin = %s\n", filter_bin);
    }


  #ifdef DEBUG
   friend int main(int c, char** args);
  #endif
 };

#endif
